#ifndef code__validation__assert_hxx_
#define code__validation__assert_hxx_

#include <code/validation/except.hxx>
#include <code/validation/traits.hxx>

#include <cstdint>
#include <source_location>
#include <sstream>
#include <string>

namespace code::validation::Assert
{

  template<typename T>
  void
  assert_true(T const&,
              std::string,
              std::source_location const& = std::source_location::current());

  template<typename T>
  void
  assert_false(T const&,
               std::string,
               std::source_location const& = std::source_location::current());

  template<typename T>
  void
  assert_null(T const&,
              std::string,
              std::source_location const& = std::source_location::current());

  template<typename T>
  void
  assert_not_null(T const&,
                  std::string,
                  std::source_location const& = std::source_location::current());

  template<typename T1, typename T2 = T1>
  void
  assert_equal(T1 const&,
               T2 const&,
               std::string,
               std::string,
               std::source_location const& = std::source_location::current());

} // namespace code::validation::Assert

#include <code/validation/assert.txx>

#endif
